freeslot("MT_PITSAVER","S_PITSAVER","S_PITSAVER_SEGMENT","S_PITSAVER_HAND",
	"SPR_PTSV","SPR_PARM","SPR_PHND","S_XPLD_RING",
	"MT_PITSAVER_HAND")
	
function A_DropRing(actor,var1,var2)
	local r = P_SpawnMobjFromMobj(actor,0,0,0,MT_FLINGRING)
	r.fuse = TICRATE*8
	r.flags = $|MF_NOCLIPTHING
	r.target = actor
	P_SetObjectMomZ(r,4*FRACUNIT)
	r.momx = actor.momx
	r.momy = actor.momy
end
states[S_XPLD_RING] = {SPR_BOM1,0,0,A_DropRing,0,0,S_XPLD1}

states[S_PITSAVER] = {SPR_PTSV,FF_ANIMATE,-1,nil,D,2,S_XPLD_RING}
states[S_PITSAVER_SEGMENT] = {SPR_PARM,A,-1,nil,0,0,S_XPLD1}
states[S_PITSAVER_HAND] = {SPR_PHND,A,-1,nil,0,0,S_XPLD1}

mobjinfo[MT_PITSAVER] = {
	--$Name "Pit Saver"
    --$Sprite PTSVA2A8
    --$Category "Buggie's custom objects"
	doomednum = 963,
	spawnstate = S_PITSAVER,
	spawnhealth = 1,
	deathsound = sfx_pop,
	deathstate = S_XPLD_RING,
	speed = 16*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_SHOOTABLE|MF_NOGRAVITY
}
mobjinfo[MT_PITSAVER_HAND] = {
	doomednum = -1,
	spawnstate = S_PITSAVER_HAND,
	spawnhealth = 1,
	deathsound = sfx_pop,
	deathstate = S_XPLD1,
	radius = 6*FRACUNIT,
	height = 6*FRACUNIT,
	dispoffset = 2,
	flags = MF_NOCLIPTHING|MF_NOCLIP
}
local function IsInZs(x,xz,y,yz)
	if x > (x+xz)
		return
	end
	if (y-yz) > (x+xz)
		return
	end
	return true
end

local function PS_DrawLine(mo,mobj)
	local onem = (mo.eflags & MFE_VERTICALFLIP) and mo.z+mo.height or mo.z
	local twom = (mobj.eflags & MFE_VERTICALFLIP) and mobj.z or mobj.z+mobj.height
	
	local cd = R_PointToDist2(mo.x,mo.y,mobj.x,mobj.y)
	local cdz = twom-onem
	local cad = R_PointToDist2(0,cd,0,abs(cdz))
	
	local ca = R_PointToAngle2(mo.x,mo.y,mobj.x,mobj.y)
	
	local cf = max(min(FixedInt(cad/8),128),6)
	for i = 1, cf
		local cx = P_ReturnThrustX(nil, ca, (cd/cf)*i)
		local cy = P_ReturnThrustY(nil, ca, (cd/cf)*i)
		local cz = (cdz/cf)*i
		
		local t = P_SpawnMobjFromMobj(mo, cx, cy, cz, MT_PARTICLE)
		t.fuse = 2
		P_MoveOrigin(t, mo.x+cx, mo.y+cy, onem+cz)
		t.state = S_PITSAVER_SEGMENT
	end
end
local function PS_PullBack(mo,mobj,rad,force,out,inrad,multi)
	local fx = mobj.x
	local fy = mobj.y
	local fz = (mobj.eflags & MFE_VERTICALFLIP) and mobj.z+mobj.height+32*mobj.scale or mobj.z-32*mobj.scale
	
	local flyto = P_AproxDistance(P_AproxDistance(fx - mo.x, fy - mo.y), fz - mo.z)
	if flyto < 1
		flyto = 1
	end
	if ((flyto > rad and not out)
	or (flyto < rad and out))
	or (flyto > rad and out and inrad and inrad >= 1 and flyto < inrad)
		local anglesucc = R_PointToAngle2(mo.x, mo.y, fx, fy)
		
		mo.momx = $ + (FixedDiv(fx - mo.x,max(force+rad,FRACUNIT))*multi)
		mo.momy = $ + (FixedDiv(fy - mo.y,max(force+rad,FRACUNIT))*multi)
		mo.momz = $ + (FixedDiv(fz - mo.z,max(force+rad,FRACUNIT))*multi)
	end
end

local reversetime = TICRATE*3
addHook("PlayerThink", function(player)
	if player.valid and player.mo and player.mo.valid
	and not player.spectator
		if not player.pitsave
			player.pitsave = {}
		end
		player.pitsave.thingpos = $ or 0
		if not player.pitsave.savepos
			player.pitsave.savepos = {}
		else
			if P_IsObjectOnGround(player.mo)
			and not player.mo.standingslope
			and (player.mo.eflags & MFE_ONGROUND)
			and not player.mo.pmomz
			and not player.cmomx
			and not player.cmomy
			and not (player.mo.momx-player.rmomx)
			and not (player.mo.momy-player.rmomy)
				player.pitsave.thingpos = $+1
				player.pitsave.savepos[player.pitsave.thingpos%reversetime] = {x = player.mo.x,y = player.mo.y,z = player.mo.z, f = P_MobjFlip(player.mo)}
			end
		end
	end
end)
addHook("MobjSpawn", function(mo)
	if mo and mo.valid
		mo.spawnpos = {x = mo.x, y = mo.y, z = mo.z, f = P_MobjFlip(mo)}
	end
end,MT_PITSAVER)
addHook("MobjThinker", function(mo)
	if mo and mo.valid
		mo.cooldown = $ or 0
		mo.destroymyself = $ or 0
		if mo.cooldown then mo.cooldown = $-1 end
		if not mo.tracer
			mo.tracer = P_SpawnMobjFromMobj(mo,0,0,0,MT_PITSAVER_HAND)
			mo.tracer.tracer = mo
		elseif mo.tracer.valid
			local hand = mo.tracer
			if not mo.target
				hand.angle = mo.angle
				hand.momx = $/7*6
				hand.momy = $/7*6
				hand.momz = $/7*6
			elseif mo.target.valid
			and mo.target.player and mo.target.player.valid
				local plr = mo.target.player
			
				hand.angle = plr.drawangle
				/*local pz = (mo.target.eflags & MFE_VERTICALFLIP) and mo.target.z-16*mo.target.scale or mo.target.z+mo.target.height+16*mo.target.scale
				P_MoveOrigin(hand,mo.target.x,mo.target.y,pz)
				hand.momx = mo.target.momx
				hand.momy = mo.target.momy
				hand.momz = mo.target.momz*/
				
				hand.momx = $/16*15
				hand.momy = $/16*15
				hand.momz = $/16*15
			end
			PS_PullBack(hand,mo,16*FRACUNIT,64*FRACUNIT,false,0,1)
			PS_DrawLine(mo,hand)
		end
		
		if not (mo.target and mo.target.valid and mo.target.health)
			local l = mo.x-1024*FRACUNIT
			local r = mo.x+1024*FRACUNIT
			local b = mo.y-1024*FRACUNIT
			local t = mo.y+1024*FRACUNIT
			searchBlockmap("objects", function(mo,mobj) //Search for players
				if mobj and mobj.valid
					if mobj != mo
					and mobj != mo.target
					and mobj.health
					and mobj.type == MT_PLAYER
					and P_CheckSight(mo,mobj)
					and mobj.player and mobj.player.valid
					and not mobj.tracer
					and not mobj.player.powers[pw_carry]
					and not mo.cooldown
						local plr = mobj.player
						if mobj.subsector and mobj.subsector.valid
						and mobj.subsector.sector and mobj.subsector.sector.valid
							local sec = mobj.subsector.sector
							if mo.subsector and mo.subsector.valid
							and mo.subsector.sector and mo.subsector.sector.valid
							and mo.subsector.sector != sec
								return
							end
							
							if GetSecSpecial(sec.special, 1) == 6 //the sector is a death pit/instakill
							or GetSecSpecial(sec.special, 1) == 7
							or GetSecSpecial(sec.special, 1) == 8
								if abs(sec.floorheight-(mobj.z+mobj.height/2+mobj.momz)) <= 640*FRACUNIT //the player is near it
								or abs(sec.ceilingheight-(mobj.z+mobj.height/2+mobj.momz)) <= 640*FRACUNIT
									mo.target = mobj
								end
							end
						end
						
						if mo.target and mo.target.valid
						and mo.target.health
						and mo.target.player and mo.target.player.valid
							local plr = mo.target.player
							if plr.pitsave
								local ptime = (plr.pitsave.thingpos)%reversetime
								local pos = plr.pitsave.savepos[ptime]
								
								mo.goto = {x = pos.x, y = pos.y, z = pos.z, f = pos.f}
								local pz = (mo.target.eflags & MFE_VERTICALFLIP) and mo.target.z-16*mo.target.scale or mo.target.z+mo.target.height+16*mo.target.scale
								P_MoveOrigin(mo.tracer,mo.target.x,mo.target.y,pz)
								S_StartSound(mo.target, sfx_s3k4a)
							end
						end
					end
				end
			end,mo,l,r,b,t)
		elseif mo.target and mo.target.valid and mo.target.health
		and mo.target.player and mo.target.player.valid
			local p = mo.target.player
			local mobj = mo.target
			PS_PullBack(mobj,mo,72*FRACUNIT,32*FRACUNIT,false,0,1)
			local fx = mobj.x
			local fy = mobj.y
			local fz = (mobj.eflags & MFE_VERTICALFLIP) and mobj.z+mobj.height+32*mobj.scale or mobj.z-32*mobj.scale
			
			local flyto = P_AproxDistance(P_AproxDistance(fx - mo.x, fy - mo.y), fz - mo.z)
			if flyto > 162*FRACUNIT
				mobj.momx = FixedMul($,mobj.friction)
				mobj.momy = FixedMul($,mobj.friction)
				mobj.momz = FixedMul($,mobj.friction)
			end
			
			p.powers[pw_carry] = CR_GENERIC
			p.pflags = $|PF_JUMPSTASIS
			mobj.spriteyoffset = -mobj.height/2
			mobj.tracer = mo.tracer
			if mobj.state != S_PLAY_RIDE
				mobj.state = S_PLAY_RIDE
			end
		end
		
		if mo.goto
			local x = mo.goto.x
			local y = mo.goto.y
			local z = mo.goto.z
			
			local gang = R_PointToAngle2(mo.x+mo.momx,mo.y+mo.momy,x,y)
			local gdif = R_PointToDist2(mo.x+mo.momx,mo.y+mo.momy,x,y)
			local gmom = R_PointToDist2(0,0,mo.momx,mo.momy)
			if gdif > 128*FRACUNIT
				P_Thrust(mo,gang,(mo.info.speed-gmom)/128)
			elseif gdif > 64*FRACUNIT
				P_InstaThrust(mo,gang,gdif/64)
			else
				if mo.target and mo.target.valid and mo.target.health
				and mo.target.player and mo.target.player.valid
					S_StartSound(mo.target, sfx_kc50)
					mo.cooldown = TICRATE
					mo.target.player.powers[pw_carry] = 0
					mo.target.tracer = nil
					mo.target.player.pflags = $|PF_THOKKED|PF_JUMPED|PF_NOJUMPDAMAGE
					mo.target.state = S_PLAY_FALL
					mo.target.momx = 0
					mo.target.momy = 0
					mo.target.momz = $/2
					mo.target.spriteyoffset = 0
					mo.target = nil
					
					if mo.flags2 & MF2_AMBUSH
						mo.destroymyself = 16
					end
				end
				mo.momx = 0
				mo.momy = 0
				if mo.goto != mo.spawnpos
					mo.goto = mo.spawnpos
				end
			end
			
			local az = z
			if mo.goto != mo.spawnpos
			and mo.goto.f
				az = $+360*FRACUNIT*mo.goto.f
			end
			local zdif = az-(mo.z)
			local zfac = 32
			mo.momz = (zdif/zfac)
		end
		
		if mo.destroymyself
			mo.destroymyself = $-1
			mo.lowtiersaver = true
		elseif mo.lowtiersaver
			mo.lowtiersaver = false
			if mo.tracer and mo.tracer.valid
				P_KillMobj(mo.tracer)
			end
			P_DamageMobj(mo,nil,nil,1,DMG_INSTAKILL)
		end
	end
end,MT_PITSAVER)